#!/usr/bin/env python
"""
Does population counts based on extracted names.
This uses the id2file table and relies heavily on
the names field to generate counts of unique names
for an id. These names are generated by the 
dl/phones/ins-id2file-names.pl script.
"""
from mysql.connector import connect, Error
from clusters import dbscan
from datetime import datetime
from collections import OrderedDict
import re, os, sys, json, math, copy

printall = False

zscore = { 0.99: 2.58, 0.95: 1.96 }

GENDERS = {
    'u': 'unknown',
    't': 'transgendered',
    'm': 'cis male',
    'f': 'cis female',
    'fu': 'cis female + unknown',
    'mu': 'cis male + unknown',
    'tu': 'transgendered + unknown',
    'all': 'all names',
    'ids': 'advertisers',
}

def printmaybe(*args, **kwargs):
    if printall: print(*args, **kwargs)

class BaseRates(object):
    def __init__(self):
        # how often site 3 users change chatids
        self.chatidrate = {"N": 4761, "rate": 0.00234917} 
        self.baserates = {}
        # advertiser relevant?
        self.baserates["RELEVANTPROB"] = {"type": "prob", "value": {"N": 3999, "prob": 0.949987 }}
        # probability name is not just a new name for the same person
        self.baserates["NAMESAMEPROB"] = {"type": "prob", "value": {"N": 431, "prob": 0.995359629}}
        # probability that a name is correct for a given id from 2014-2016 data
        self.baserates["PNAMECORRECT"] = {"type": "prob", "value": {"N": 3553, "prob": 0.9612}}
        # estimated average rate for the same person adding new ids per day
        # based on site3 chatid data
        self.baserates["IDCHANGERATE"] = {"type": "rate", 
                "value": ({"N": 674, "rate": 0.022255193}, self.chatidrate)}

    def __repr__(self):
        return json.dumps(self.baserates)

class RateBounds(object):
    """
    Given a set of BaseRates generate the confidence intervals
    for each parameter.
    This creates a dict of dicts with a value, lower and upper bound
    derived from each BaseRate.
    """

    def _extract(self, r):
        return r["prob"] if "prob" in r else r["rate"] if "rate" in r else r["value"]

    def _value(self, rate):
        """
        errors are summed if there are more than one of them
        """
        if isinstance(rate, tuple):
            return sum(map(self._extract, rate))
        return self._extract(rate)

    def _se(self, rate):
        """
        get standard error
        """
        if "prob" in rate:
            # https://www.statology.org/standard-error-of-proportion/
            return self.z*rate["prob"]*(1-rate["prob"])/math.sqrt(rate["N"])
        elif "rate" in rate:
            # for poisson rates mean = sd = rate
            return self.z*rate["rate"]/math.sqrt(rate["N"])

    def _rss(self, errors):
        """
        root sum of squares
        """
        # https://www.webassign.net/question_assets/unccolphysmechl1/measurements/manual.html eqn 27
        return math.sqrt(sum(map(lambda e: e**2, errors)))

    def _set_rate_bounds(self, baserates):
        """
        given a list of rates add in "upper" and "lower" to reflect
        uncertainty in scaling back counts
        """
        rates = {}
        for name, rateinfo in baserates.baserates.items():
            value = None
            rate = rateinfo["value"]
            if isinstance(rate, tuple):
                ci = self._rss(map(self._se, rate))
                value = self._value(rate)
            else:
                ci = self._se(rate)
                value = self._value(rate)

            upper = min(1.0, value + ci)
            lower = max(0.0, value - ci)

            if rateinfo["type"] == "rate":
                lower, upper = upper, lower

            rates[name] = {"value": value, "lower": lower, "upper": upper}

        return rates

    def __init__(self, conflevel, baserates=BaseRates()):
        self.z = zscore[conflevel]
        self.rates = self._set_rate_bounds(baserates)

    def __repr__(self):
        return json.dumps(self.rates)

class Names(object):
    def __init__(self, grpnames, start, end):
        self.grpnames = float(grpnames)
        self.start = datetime.strptime(start,"%Y-%m-%d")
        self.end = datetime.strptime(end,"%Y-%m-%d")
        delta = self.end.date() - self.start.date()
        self.maxdays = float(delta.days)
        self.names = {}
        self.meta = {}
        self.genders = []
        self.rawidcount = 0
        self.scaledids = 0
        self.scaledidslower = 0
        self.scaledidsupper = 0

    def add_names(self, ID, gender, namelist, start, end, collective):
        """
        given an ID, gender and comma separated list of 
        names append these to the names dictionary
        this should be done all at once before querying
        """
        if gender is None:
            gender = 'u'

        if gender not in self.genders:
            self.genders.append(gender)

        if ID not in self.meta:
            self.meta[ID] = {"start": start, "end": end, "collective": collective, "genders": {}}
        self.meta[ID]['genders'][gender] = 1

        if namelist is None or namelist == '':
            if ID not in self.names:
                self._add_one(ID, gender, None)
        else:
            for name in namelist.split(","):
                self._add_one(ID, gender, name)

    def _id2name(self, ID):
        newname = '__ID {0}__'.format(ID)
        return newname

    def _is_name_id(self, name):
        try:
            if re.match(r'^__ID .*__$', name):
                return True
            return False
        except Exception as e:
            print("failed to check name {0}".format(name))
        return is_name_id

    def _add_one(self, ID, gender, name):
        if ID not in self.names:
            self.names[ID] = {}
        if gender not in self.names[ID]:
            self.names[ID][gender] = {}
        if name is None:
            return
        if name not in self.names[ID][gender]:
            self.names[ID][gender][name] = 1

    def get(self, ID, gender=None, name=None):
        """
        get stats for a given gender and/or name
        """
        if ID not in self.names:
            return None
        if gender is not None:
            if gender not in self.names[ID]:
                return None
            if name is not None:
                if name not in self.names[ID][gender]:
                    return None
                return self.names[ID][gender][name]
            return self.names[ID][gender]

        if name is not None:
            namedict = {}
            for g, nlist in self.names[ID]:
                for n in nlist:
                    if n not in namedict:
                        namedict[n] = 0
                    namedict[n] += self.names[ID][g][n]
            return namedict
        return self.names[ID]

    def merge(self, clusters):
        """
        add to an amalgamated list of names for a cluster
        """
        self.rawidcount = len(self.names.keys())
        self.clusters = clusters
        newids = []
        for ID, clusterid in clusters.items():
            if self.get(ID) is None:
                continue 

            newid = "cluster {0}".format(clusterid)
            if newid not in newids:
                newids.append(newid)
                self.names[newid] = {}

            if newid not in self.meta:
                self.meta[newid] = {}

            if "genders" not in self.meta[newid]:
                self.meta[newid]["genders"] = {}
            self.meta[newid]["genders"] = {**self.meta[newid]["genders"], **self.meta[ID]["genders"]}

            if "end" not in self.meta[newid] \
                    or self.meta[ID]["end"] > self.meta[newid]["end"]:
                self.meta[newid]["end"] = self.meta[ID]["end"]

            if "start" not in self.meta[newid] or self.meta[ID]["start"] < self.meta[newid]["start"]:
                self.meta[newid]["start"] = self.meta[ID]["start"]
                        
            if "collective" not in self.meta[newid]:
                self.meta[newid]["collective"] = 0

            if self.meta[ID]["collective"] == 1:
                self.meta[newid]["collective"] = 1

            for gender, namedict in self.get(ID).items():
                if gender not in self.names[newid]:
                    self.names[newid][gender] = {}
                for name, count in namedict.items():
                    if self._is_name_id(name):
                        continue
                    if name not in self.names[newid][gender]:
                        self.names[newid][gender][name] = 0
                    self.names[newid][gender][name] += count
            del(self.names[ID])

        for newid in newids:
            for gender, items in self.names[newid].items():
                if len(items) == 0:
                    self.names[newid][gender][self._id2name(newid)] = 1


    def namecount(self, ID, gender, grpnames=1, 
            namesameprob=None, idrate=None, scalerelevant=None,
            pnamecorrect = 1):
        """
        get the count of names for a given ID and gender
        named parameters:
        grpnames - how many people a "collective" should be 
        namesameprob - prob this name is unique to the person
        idrate - how many new ids are generated per day per ID
        scalerelevant - reduce further based on actual actual proportion of sp ads
        pnamecorrect - probability that id/name pair is valid
        """
        count = 0
        start = None
        end = None
        # make sure the days do not exceed the original time period
        if self.meta[ID]["start"] < self.start:
            start = self.start
        elif self.meta[ID]["start"] > self.end:
            return 0
        else:
            start = self.meta[ID]["start"]

        if self.meta[ID]["end"] > self.end:
            end = self.end
        else:
            end = self.meta[ID]["end"]

        startdt = start.date()
        enddt = end.date()
        delta = enddt - startdt
        days = float(delta.days)
        if days < 0.0:
            return 0
            # raise(Exception(f"{ID} invalid days {self.meta[ID]} enddt {enddt} startdt {startdt} end {end} start {start}"))
        elif days == 0.0:
            days = 1

        # self.maxdays  is the total number of days for the period studied
        inverteddays = (self.maxdays/days)

        collective = self.meta[ID]["collective"]

        namedict = self.get(ID,gender=gender)
        if namedict is None:
            return 0

        count = len(namedict.keys())
        if count == 0:
            if collective:
                count = grpnames/len(self.meta[ID]["genders"].keys())
            else:
                count = 1/len(self.meta[ID]["genders"].keys())

        # this is not currently being used - for the whole 2 year period it seems to result in < 10% increase
        mediandayspername = days

        if namesameprob is not None:
            # reduce number of names based on a expected name changes
            actualnames = count * namesameprob
        else:
            actualnames = count

        if idrate is not None:
            # see how id churn affects the number of effective ids
            actualids = 1 / (1 + (inverteddays - 1) * idrate)
        else:
            actualids = 1

        scalednames = actualnames * actualids * pnamecorrect 
        scaledid = actualids
        
        # reduce further based on number of ids that are valid from counts
        if scalerelevant is not None:
            scaledid *= scalerelevant
            scalednames *= scalerelevant

        self.scaledids += scaledid
        return scalednames

    def adcount(self, ID, gender=None):
        """
        get how many ads for a given ID and gender
        """
        posts = 0
        if gender is None:
            names = self.get(ID)
            for g, namedict in names.items():
                for n, f in namedict.items():
                    posts += f
        else:
            namedict = self.get(ID, gender=gender)
            for n, f in namedict.items():
                posts += f
        return posts

    def gendersum(self, gender, **kwargs):
        """
        get total unique names for a given gender
        """
        total = 0
        for ID in self.names.keys():
            total += self.namecount(ID, gender, **kwargs)
        return total

    def gendertotals(self, **kwargs):
        """
        returns a dict with counts by gender
        as well as dicts of the upper bound and lower bound estimated ci
        """
        totals = OrderedDict()
        self.scaledids = 0
        sortedgenders = sorted(self.genders)
        for gender in sortedgenders:
            totals[gender] = self.gendersum(gender, **kwargs)
        return totals

    def _add_unknown(self, gender, genders, total):
        """
        add back in a proportion of unknowns based on gender proportion
        """
        if gender not in genders:
            return 0
        if 'u' not in genders or total == 0 or genders['u'] == 0:
            return genders[gender]
        return genders[gender] + genders[gender]/total*genders['u']

    def finaltally(self, start, end, **kwargs):
        """
        generates counts based on the contents of the names object
        uses name and id rate to correct the name counts based on a known
        rate of inflation for names per day
        returns an expanded groups of tallys for various things
        """
        genders = self.gendertotals(**kwargs)
        total = sum(genders.values())
        genders['start'] = start
        genders['end'] = end
        genders['clusters'] = max(self.clusters.values())
        genders['rawids'] = self.rawidcount
        genders['all'] = total
        genders['fu'] = self._add_unknown('f',genders,total)
        genders['mu'] = self._add_unknown('m',genders,total)
        genders['tu'] = self._add_unknown('t',genders,total)
        genders['ids'] = round(self.scaledids)
        return genders

    def __repr__(self):
        return json.dumps(self.names, indent=4, sort_keys=True)

def estimate(db, start, end, conflevel=0.95):
    """
    Using a specific db and start and end dates, get population estimate
    """
    neighbours = {}
    ads = {}
    try:
        with connect(
                database=db, 
                user=os.environ['PPDBUSER'], 
                password=os.environ['PPDBPW'], 
                host='localhost'
            ) as conn:

            grpnames = 1
            with conn.cursor() as cursor:
                cursor.execute(
                    """select median(namecount) over () grpnames 
                    from ids where namecount > 1 and type in ('phone','email','chatname') 
                    limit 1""")
                row = cursor.fetchone()
                grpnames = row[0]
                printmaybe("grpnames",grpnames)

            names = Names(grpnames, start, end)
            with conn.cursor() as cursor:
                query =  \
                    """select f.id,f.fid,a.gender,a.names,i.min,i.max,i.collective 
                    from ids i join id2file f on i.id=f.id join ads a on a.fid=f.fid   
                    join files s on s.fid=a.fid 
                    where a.keep > 0 and 
                    f.type in ('phone','email','chatname')
                    and (
                        (s.lastdate >= '{0}' and s.firstdate <= '{1}')
                    )""".format(start, end)
                cursor.execute(query)
                for row in cursor:
                    ID, fid, gender, namelist, idstart, idend, collective = row
                    try:
                        names.add_names(ID, gender, namelist, idstart, idend, collective)
                    except Exception as e:
                        print("failed to add name: {0}".format(e))
                    if fid not in ads:
                        ads[fid] = {}
                    if ID not in ads[fid]:
                        ads[fid][ID] = 0
                    ads[fid][ID] += 1
    except Error as e:
        raise Exception("db query failed: {0}".format(e))

    # find neighbours
    for fid, ids in ads.items():
        for id1 in ids.keys():
            for id2 in ids.keys():
                if id1 != id2 and id1 < id2:
                    if id1 not in neighbours:
                        neighbours[id1] = {}
                    if id2 not in neighbours:
                        neighbours[id2] = {}
                    if id2 not in neighbours[id1]:
                        neighbours[id1][id2] = 0
                    if id1 not in neighbours[id2]:
                        neighbours[id2][id1] = 0
                    neighbours[id1][id2] += 1
                    neighbours[id2][id1] += 1

    # find clusters
    clusters = dbscan(neighbours)
    if clusters is None or len(clusters.keys()) == 0 or len(clusters.values()) == 0:
        return

    printmaybe(len(clusters.keys()), "ids in clusters", max(clusters.values()), "clusters", 
            len(names.names.keys()),"ids before")
    # get names for the clusters
    names.merge(clusters)

    # what to calculate
    # calculates "upper" and "lower" rates to account for confidence intervals
    rates = RateBounds(conflevel).rates
    printmaybe(rates)
    resultopts = OrderedDict({
        "raw counts": {},
        "collectives added": {"grpnames": grpnames },
        "scaled counts": {"grpnames": grpnames, 
            "idrate": rates["IDCHANGERATE"]["value"], "namesameprob": rates["NAMESAMEPROB"]["value"], 
            "scalerelevant": rates["RELEVANTPROB"]["value"], "pnamecorrect": rates["PNAMECORRECT"]["value"] },
        "scaled counts lower": {"grpnames": grpnames, 
            "idrate": rates["IDCHANGERATE"]["lower"], "namesameprob": rates["NAMESAMEPROB"]["lower"], 
            "scalerelevant": rates["RELEVANTPROB"]["lower"], "pnamecorrect": rates["PNAMECORRECT"]["lower"] },
        "scaled counts upper": {"grpnames": grpnames, 
            "idrate": rates["IDCHANGERATE"]["upper"], "namesameprob": rates["NAMESAMEPROB"]["upper"], 
            "scalerelevant": rates["RELEVANTPROB"]["upper"], "pnamecorrect": rates["PNAMECORRECT"]["upper"] },
    })

    # want this to be all on one line for post processing
    results = OrderedDict()
    for key, opts in resultopts.items(): 
        results[key] = names.finaltally(start, end, **opts)
    return results

def get_args():
    # 3 required arguments
    db,start,end = sys.argv[1:4]

    # and 1 optional: the confidence level
    if len(sys.argv) >= 5:
        conflevel = float(sys.argv[4])
    else:
        conflevel = 0.95

    return (db, start, end, conflevel)

if __name__ == '__main__':
    printall = True
    db, start, end, conflevel = get_args()
    print("db",db,"start",start,"end",end,"conflevel",conflevel)
    print(json.dumps(estimate(db,start,end,conflevel)))

